SystemOrganization addCategory: #'Khami-Web'!

WATask subclass: #KmGameTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameTask class methodsFor: 'class initialization' stamp: 'StuartHerring 4/10/2011 16:43'!
initialize
	(WAAdmin register: self asApplicationAt: 'vok')
		preferenceAt: #sessionClass put: KmSession;
		 addLibrary: PTDevelopmentLibrary;
		  addLibrary: SUDeploymentLibrary.
	WADispatcher default defaultName: 'vok'.
		! !

!KmGameTask methodsFor: 'running' stamp: 'StuartHerring 5/14/2011 22:17'!
go
	| game |
	game := self call: KmSetupGame new.
	self session game: game.
	[ game isComplete ] whileFalse: [
		| location |
		game nextPlayer.
		location := self call: KmPlaceTileScreen new.
		location ifNotNil: [ | segment |
			game placeCurrentTileAtRow: location x andColumn: location y.
			game currentPlayer pieces isEmpty ifFalse: [
				segment := self call: KmPlacePieceScreen new.
				segment ifNotNil: [ segment piece: game currentPlayer takePiece ]]].
		game calculateScore].
	game calculateFinalScore.
	self call: KmVictoryScreen new.
	! !

WAPresenter subclass: #KmBlankTileRenderable
	instanceVariableNames: 'callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmBlankTileRenderable methodsFor: 'accessing' stamp: 'StuartHerring 3/20/2011 12:24'!
callback: aBlock
	callback := aBlock! !

!KmBlankTileRenderable methodsFor: 'initialization' stamp: 'StuartHerring 3/20/2011 12:26'!
initialize
	 super initialize.
	callback := nil	! !

!KmBlankTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 5/10/2011 21:18'!
renderContentOn: html
	html table
		onClick: (callback ifNotNil: ['window.location = "', (html urlForAction:  callback) printString, '";']);
		class: (KmTile name); 
		class: (callback ifNotNil: ['clickable']);
			with: [self renderTileOn: html]! !

!KmBlankTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 5/9/2011 20:52'!
renderTileOn: html! !

KmBlankTileRenderable subclass: #KmTextTileRenderable
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTextTileRenderable class methodsFor: 'instance creation' stamp: 'StuartHerring 3/20/2011 12:33'!
text: aString 
	^self basicNew
		initializeWithText: aString;
		yourself! !

!KmTextTileRenderable methodsFor: 'initialization' stamp: 'StuartHerring 3/20/2011 12:33'!
initializeWithText: aString
	self initialize.
	text := aString! !

!KmTextTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 14:24'!
renderTileOn: html
	html tableRow: [html tableData class: 'text'; with: text]! !

KmBlankTileRenderable subclass: #KmTileRenderable
	instanceVariableNames: 'tile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

KmTileRenderable subclass: #KmPlacePieceTileRenderable
	instanceVariableNames: 'segmanetCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmPlacePieceTileRenderable class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/10/2011 22:08'!
for: aTile callback: aSingleArgumentBlock
	^(self for: aTile)
		segmentCallback: aSingleArgumentBlock;
		yourself! !

!KmPlacePieceTileRenderable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/10/2011 22:24'!
renderRegion: aRegion on: html
	| segment |
	segment := tile at: aRegion.
	html tableData 
		class: (self classFor: (tile at: aRegion));
		with: [ segment canPlacePiece ifTrue: [html anchor class:#piece; callback: [ segmanetCallback value: segment ] ; with: '( )']]! !

!KmPlacePieceTileRenderable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/10/2011 22:04'!
segmentCallback: aBlock
	segmanetCallback := aBlock.! !

!KmTileRenderable class methodsFor: 'instance creation' stamp: 'StuartHerring 1/13/2011 19:40'!
for: aTile
	^self basicNew
		initializeWithTile: aTile;
		yourself! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 1/31/2011 23:07'!
classFor: aRegion
	^String streamContents: [ :s |
		s nextPutAll: aRegion type.
		aRegion isComplete ifTrue: [s nextPut: $C]]! !

!KmTileRenderable methodsFor: 'initialization' stamp: 'StuartHerring 3/20/2011 12:25'!
initializeWithTile: aTile
	self initialize.
	tile := aTile.! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 14:24'!
renderBlankOn: html
	html tableData! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 5/8/2011 17:04'!
renderCornerFor: aRegion1 and: aRegion2 on: html
	| pattern class suffix segment1 segment2 |
	segment1 := tile at: aRegion1.
	segment2 := tile at: aRegion2.
	
	((segment1 type = segment2 type) 
		and: [(segment1 isComplete = segment2 isComplete) 
		and: [(segment1 isWall or: [segment2 isWall]) not]])
	ifTrue: [	class := self classFor: segment1]
	ifFalse: [
		pattern := ({LeftTop. TopRight} includes: aRegion1)  
			ifTrue: ['{1}{2}{3}'] 
			ifFalse: ['{2}{1}{3}'].
		suffix :=({LeftTop. RightBottom} includes: aRegion1)
			ifTrue: [1]
			ifFalse: [2].
		class := pattern format: {
			self classFor: segment1.
			self classFor: segment2.
			suffix}].	
	html tableData class: class
	! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 5/8/2011 18:34'!
renderInnerCornerFor: aRegion1 and: aRegion2 on: html
	| pattern class suffix segment1 segment2 |
	segment1 := (tile at: aRegion1) isRoad 
		ifFalse: [tile at: aRegion1]
		ifTrue: [tile at: (aRegion1 edge locations third)].
	segment2 := (tile at: aRegion2) isRoad 
		ifFalse: [tile at: aRegion2]
		ifTrue: [tile at: (aRegion2 edge locations first)].
	
	((segment1 type = segment2 type) 
		and: [(segment1 isComplete = segment2 isComplete) 
		and: [(segment1 isWall or: [segment2 isWall]) not]])
	ifTrue: [	class := self classFor: segment1]
	ifFalse: [
		pattern := ({Left.Top} includes: aRegion1 edge)  
			ifTrue: ['{1}{2}{3}'] 
			ifFalse: ['{2}{1}{3}'].
		suffix :=({Left. Right} includes: aRegion1 edge)
			ifTrue: [1]
			ifFalse: [2].
		class := pattern format: {
			self classFor: segment1.
			self classFor: segment2.
			suffix}].	
	html tableData class: class
	! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 4/25/2011 15:15'!
renderLiteralTileOn: html
		html tableRow: [
			self renderBlankOn: html.  
			self renderRegion: TopLeft on: html.
			self renderRegion: Top on: html.
			self renderRegion: TopRight on: html.
			self renderBlankOn: html.		].
		html tableRow: [ 
			self renderRegion: LeftTop on: html.
			self renderBlankOn: html.  
			self renderRegion: CentreTop on: html.
			self renderBlankOn: html.  
			self renderRegion: RightTop on: html.
		].
		html tableRow: [
			self renderRegion: Left on: html.
			self renderRegion: CentreLeft on: html.
			self renderRegion: Centre on: html.
			self renderRegion: CentreRight on: html.
			self renderRegion: Right on: html.
			].
		html tableRow: [ 
			self renderRegion: LeftBottom on: html.
			self renderBlankOn: html.  
			self renderRegion: CentreBottom on: html.
			self renderBlankOn: html.  
			self renderRegion: RightBottom on: html.
		].
		html tableRow: [
			self renderBlankOn: html.  
			self renderRegion: BottomLeft on: html.
			self renderRegion: Bottom on: html.
			self renderRegion: BottomRight on: html.
			self renderBlankOn: html.  
		]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 5/11/2011 23:37'!
renderRegion: aRegion on: html
	| segment |
	segment := tile at: aRegion.
	(html tableData)
		class: (self classFor: segment);
		with: [ 
			segment hasPiece 
				ifTrue: [ html span class: #piece; style: 'color: ', segment piece colour asHTMLColor; with: '*']
				ifFalse: [self session displayMode = #literal 
					ifTrue: [ html text: (segment isWall 
							ifTrue: [$W]
							ifFalse: [segment territory class codeCharacter])]]]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 5/8/2011 17:15'!
renderSymbolicTileOn: html
		html tableRow: [
			self renderCornerFor: LeftTop and: TopLeft on: html.
			self renderRegion: TopLeft on: html.
			self renderRegion: Top on: html.
			self renderRegion: TopRight on: html.
			self renderCornerFor: TopRight and: RightTop on: html.
		].
		html tableRow: [ 
			self renderRegion: LeftTop on: html.
			self renderInnerCornerFor: CentreLeft and:  CentreTop on:  html.
			self renderRegion: CentreTop on: html.
			self renderInnerCornerFor: CentreTop and:  CentreRight on:  html.
			self renderRegion: RightTop on: html.
		].
		html tableRow: [
			self renderRegion: Left on: html.
			self renderRegion: CentreLeft on: html.
			self renderRegion: Centre on: html.
			self renderRegion: CentreRight on: html.
			self renderRegion: Right on: html.
			].
		html tableRow: [ 
			self renderRegion: LeftBottom on: html.
			self renderInnerCornerFor: CentreBottom and:  CentreLeft on:  html.
			self renderRegion: CentreBottom on: html.
			self renderInnerCornerFor: CentreRight and:  CentreBottom on:  html.
			self renderRegion: RightBottom on: html.
		].
		html tableRow: [
			self renderCornerFor: BottomLeft and: LeftBottom on: html.
			self renderRegion: BottomLeft on: html.
			self renderRegion: Bottom on: html.
			self renderRegion: BottomRight on: html.
			self renderCornerFor: RightBottom and: BottomRight on: html.
		]! !

!KmTileRenderable methodsFor: 'rendering' stamp: 'StuartHerring 4/25/2011 15:16'!
renderTileOn: html
	self session displayMode = #symbolic 
		ifTrue: [self renderSymbolicTileOn: html  ]
		ifFalse: [self renderLiteralTileOn: html  ]! !

WAPresenter subclass: #KmCurrentPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmCurrentPlayer methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/11/2011 07:45'!
renderContentOn: html
	| player |
	player := self session game currentPlayer.
	html heading level: 2; with: player name.
	html div id: #currentPlayer; with: [
		html heading level: 3; style: 'background-color: ', player colour asHTMLColor;with: [html space].
		html heading level: 3; with: 'Score: ', player score printString.
		html heading level: 3; with: 'Pieces: ', player pieces size printString.
	]! !

WAPresenter subclass: #KmPlayerList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmPlayerList methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/11/2011 07:37'!
renderContentOn: html
	html heading level: 2; with: 'Players'.
	html unorderedList id: #playerList; with: [
		self session game players do: [ :p |
			html listItem: [html span style: 'background-color: ', p colour asHTMLColor. 
				html render: ('{1} ({2})' format: {p name. p score})]]]! !

WAFileLibrary subclass: #KmResources
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
farmcvillage1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 72 73 68 65 84 24 211 141 208 209 9 0 32 8 69 209 235 163 109 154 167 41 155 167 121 236 43 144 168 204 47 149 35 168 214 192 43 121 168 59 140 31 8 240 131 181 146 12 43 22 47 172 189 113 195 58 77 159 176 110 59 237 88 175 75 35 46 217 255 186 3 6 19 200 100 23 56 190 212 170 201 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
farmcvillage2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 75 73 68 65 84 40 207 173 204 177 13 0 32 8 68 209 143 235 56 15 251 143 130 133 161 209 24 5 252 201 21 215 60 1 179 185 90 170 34 0 237 23 212 251 252 105 112 133 188 48 120 130 194 224 13 122 6 95 161 43 24 133 142 96 22 218 192 42 228 137 42 128 89 21 242 6 59 126 15 201 62 213 56 129 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 178 50 53 215 54 52 176 50 48 0 0 65 110 5 13 70 178 31 76 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 178 50 53 215 54 52 176 50 48 0 0 65 110 5 13 36 138 232 179 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
farmcvillagec1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 57 73 68 65 84 24 211 141 202 183 13 0 48 12 196 64 106 72 237 63 202 187 51 28 148 8 176 59 28 164 193 32 228 83 56 193 27 118 248 130 21 254 96 134 67 24 225 20 190 184 132 39 54 132 104 114 131 5 202 170 175 168 151 148 219 204 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
farmcvillagec2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 73 73 68 65 84 40 207 173 206 49 10 0 48 8 3 64 125 164 255 127 138 29 172 29 90 68 141 21 66 50 29 50 145 170 101 118 34 204 123 58 136 69 196 12 123 73 21 6 111 8 6 35 168 13 102 80 25 172 66 41 216 133 66 16 133 30 112 10 29 240 23 228 189 0 67 175 95 93 44 178 9 213 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 50 183 50 176 212 54 52 176 50 48 0 0 65 123 5 14 232 59 153 149 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 50 183 50 176 212 54 52 176 50 48 0 0 65 123 5 14 138 3 110 106 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
farmvillage1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 69 73 68 65 84 24 211 99 12 101 96 248 175 205 64 24 48 173 110 96 96 184 74 140 66 6 6 6 6 98 20 51 193 24 132 20 51 33 115 240 41 102 66 23 192 165 152 9 155 110 108 138 153 112 185 9 93 49 19 62 159 34 43 102 34 20 126 48 197 0 136 73 19 147 62 192 250 17 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
farmvillage2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 75 73 68 65 84 40 207 173 204 177 13 0 32 8 0 193 215 117 156 135 125 216 28 11 67 163 49 138 248 221 55 87 64 21 204 72 38 162 10 80 127 65 173 141 127 6 103 200 11 131 59 40 12 158 160 107 240 22 58 130 81 104 11 190 66 11 152 133 188 34 2 96 150 133 188 14 139 98 23 185 226 3 143 254 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 176 50 52 215 54 52 176 50 48 0 0 65 58 5 7 184 194 24 42 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 176 50 52 215 54 52 176 50 48 0 0 65 58 5 7 218 250 239 213 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
farmvillagec1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 70 73 68 65 84 24 211 141 208 209 9 0 32 8 69 209 203 219 177 230 113 159 134 180 175 66 162 52 65 72 57 130 73 3 247 143 4 195 127 176 0 134 65 39 15 173 71 133 21 139 12 235 108 188 176 110 211 55 172 215 78 39 86 246 211 136 85 92 101 227 9 127 38 50 30 235 106 31 229 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
farmvillagec2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 81 73 68 65 84 40 207 173 210 193 9 0 32 12 67 209 175 59 118 159 206 227 146 245 80 4 17 68 91 205 37 228 242 78 41 160 10 102 60 70 68 21 160 254 130 90 243 157 6 87 104 36 12 238 160 48 120 130 174 193 91 232 8 70 161 45 152 133 166 248 15 69 0 204 252 145 249 230 23 52 186 3 185 33 101 180 162 201 223 86 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 181 50 52 213 54 52 176 50 48 0 0 65 94 5 10 86 17 39 127 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 181 50 52 213 54 52 176 50 48 0 0 65 94 5 10 52 41 208 128 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'css' stamp: 'StuartHerring 5/14/2011 22:08'!
styleCss
	^'html {
	background: #aaccff;
	font-family: sans-serif;
}

.disabled table {
background-color: grey;
}
.clickable {
	cursor: pointer;
}

#sidebar {
	float: left;
	width: 10em;
	margin-right: 0.5em;
	background: silver;
}

#sidebar h2 {
	font-size: 0.8em;
	background-color: gray;
	margin: 0;
	line-height: 1.5em;
	text-align: center;
	vertical-align: middle;
}

ul#playerList  {
	margin: 0;
	padding: 0;
}

#playerList li {
	padding: 0;
	margin-left: 3px;
	list-style: none;
}

#playerList li span {
	display: inline-block;
	width: 0.7em;
	height: 0.7em;
	margin-right: 0.2em;
}

#tilelist p {
	margin: 0;
	text-align: center;
	font-size: 0.8em;
	font-weight: bold;
	float: left;
	color: white;
}

#tilelist a {
	float: right;
	clear: right;
	margin-bottom: 1em;
	font-size: 0.8em;
}

#summary {
	padding: 0.5em;
	margin: 0;
	width: 9em;
}

#summary dt {
	clear: left;
	font-weight: bold;
	width: 4em;
}

#summary dd {
	clear: right;
	margin-left: 0.5em;
	width: 3em;
}

#currentPlayer h3 {
	margin: 0;
	font-size: 1em;
}
ul#menu { 
	padding: 0;
	margin: 0;
	margin-bottom: 5px;
}

#menu li {
	padding-left: 3px;
	padding-right: 3px;
	margin: 0;
	list-style: none;
	border-bottom: 1px solid black;
}

#menu li:hover {
	background: gray;
}

#menu li a {
	text-decoration: none;
	color: #aa0000;
	margin: 0;
	font-size: 0.8em;
}

#menu li a:hover {
	color: silver;
}

table.gameBoard {
	border-collapse: collapse;
	border-color: gray;
	padding: 0;
}

table.gameBoard td {
	width: 52px;
	height: 52px;
	padding: 0px;
}

table.gameBoard td.available {
	background-color: white;
}

table.gameBoard td.available:hover {
	background-color: silver;
}

table.gameBoard td.available a {
	display: block;
	margin: 0;
	height: 100%;
	width: 100%;
	text-decoration: none;
}

table.gameBoard td.lastTile {
	border: white 1px solid;
}

table.KmTile {
	border: 1px black solid;
	padding: 0;
	border-spacing: 0;
	border-collapse: collapse;
}

table.KmTile td {
	width: 10px;
	height: 10px;
	line-height: 6px;
	background-color: transparent;
	padding: 0;
	font-size: 6px;
	text-align: center;
	vertical-align: middle;
}

table.KmTile td.text {
	line-height: 1em;
	width: 50px;
	height: 50px;
	text-align: center;
	font-size: 1em;
}

a.piece {
	text-decoration: none;
	color: inherit;
}

a.piece:hover {
	color: red;
	text-weight: bold;
}

span.piece {
	border-style: solid;
	border-width: 1px;
	display: inline-block;
	height: 50%;
	width: 50%;
	text-align: center;
	vertical-align: middle;
}

.KmTile td.farm {
	background: green;
}

.KmTile td.farmC {
	background: lime;
}

.KmTile td.village {
	background: maroon;
	color: silver;
}

.KmTile td.villageC {
	background: red;
}

.KmTile td.wall {
	background: #550000;
}

.KmTile td.road {
	background: white;
}

.KmTile td.roadC {
	background: black;
	color: silver;
}

.KmTile td.hut {
	background: cyan;
}

.KmTile td.farmvillage1 {
	background-image: url("/files/KmResources/farmvillage1.png");
}
.KmTile td.farmvillage2 {
	background-image: url("/files/KmResources/farmvillage2.png");
}
.KmTile td.farmCvillage1 {
	background-image: url("/files/KmResources/farmcvillage1.png");
}
.KmTile td.farmCvillage2 {
	background-image: url("/files/KmResources/farmcvillage2.png");
}
.KmTile td.farmvillageC1 {
	background-image: url("/files/KmResources/farmvillagec1.png");
}
.KmTile td.farmvillageC2 {
	background-image: url("/files/KmResources/farmvillagec2.png");
}
.KmTile td.farmCvillageC1 {
	background-image: url("/files/KmResources/farmcvillagec1.png");
}
.KmTile td.farmCvillageC2 {
	background-image: url("/files/KmResources/farmcvillagec2.png");
}

.KmTile td.villagefarm1 {
	background-image: url("/files/KmResources/villagefarm1.png");
}
.KmTile td.villagefarm2 {
	background-image: url("/files/KmResources/villagefarm2.png");
}
.KmTile td.villagefarmC1 {
	background-image: url("/files/KmResources/villagefarmc1.png");
}
.KmTile td.villagefarmC2 {
	background-image: url("/files/KmResources/villagefarmc2.png");
}
.KmTile td.villageCfarm1 {
	background-image: url("/files/KmResources/villagecfarm1.png");
}
.KmTile td.villageCfarm2 {
	background-image: url("/files/KmResources/villagecfarm2.png");
}
.KmTile td.villageCfarmC1 {
	background-image: url("/files/KmResources/villagecfarmc1.png");
}
.KmTile td.villageCfarmC2 {
	background-image: url("/files/KmResources/villagecfarmc2.png");
}

.KmTile td.villagevillage1 {
	background-image: url("/files/KmResources/villagevillage1.png");
}
.KmTile td.villagevillage2 {
	background-image: url("/files/KmResources/villagevillage2.png");
}
.KmTile td.villageCvillage1 {
	background-image: url("/files/KmResources/villagecvillage1.png");
}
.KmTile td.villageCvillage2 {
	background-image: url("/files/KmResources/villagecvillage2.png");
}

.KmTile td.villagevillageC1 {
	background-image: url("/files/KmResources/villagevillagec1.png");
}
.KmTile td.villagevillageC2 {
	background-image: url("/files/KmResources/villagevillagec2.png");
}
.KmTile td.villageCvillageC1 {
	background-image: url("/files/KmResources/villagecvillagec1.png");
}
.KmTile td.villageCvillageC2 {
	background-image: url("/files/KmResources/villagecvillagec2.png");
}

.KmTile td.villageCvillageC1 {
	background-image: url("/files/KmResources/villagecvillagec1.png");
}
.KmTile td.villageCvillageC2 {
	background-image: url("/files/KmResources/villagecvillagec2.png");
}
'! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
villagecfarm1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 75 73 68 65 84 24 211 141 208 219 9 0 49 8 68 209 155 233 209 173 39 245 36 69 78 190 22 150 205 195 8 130 202 17 196 18 224 94 73 67 13 136 27 8 112 131 245 22 25 214 183 57 97 253 7 59 172 213 246 10 107 119 211 132 13 62 101 128 169 184 24 156 253 240 1 6 83 210 34 32 63 170 115 231 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:47'!
villagecfarm2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 83 73 68 65 84 40 207 165 210 177 13 0 32 8 4 192 199 29 101 30 246 113 72 44 244 19 19 99 20 249 2 8 197 133 2 113 7 128 81 51 81 157 3 193 223 94 43 21 51 192 189 100 47 106 205 108 221 135 193 19 20 6 111 208 51 248 10 93 193 40 116 4 127 161 13 204 66 140 240 143 178 16 211 1 49 187 68 75 146 65 227 62 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 181 50 53 215 54 52 176 50 48 0 0 65 140 5 16 20 211 120 65 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 181 50 53 215 54 52 176 50 48 0 0 65 140 5 16 118 235 143 190 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:48'!
villagecfarmc1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 56 73 68 65 84 24 211 141 202 177 17 0 32 12 195 64 49 36 236 191 137 41 40 128 35 33 150 218 167 131 204 145 137 145 137 23 52 240 134 5 190 225 7 191 48 193 49 12 112 14 79 220 4 162 104 0 19 194 179 175 168 241 67 210 227 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:50'!
villagecfarmc2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 68 73 68 65 84 40 207 173 204 187 9 0 48 8 69 209 151 33 117 255 77 76 17 109 2 226 87 184 106 117 142 8 0 188 61 25 102 125 12 236 94 34 83 180 53 168 11 186 80 21 12 161 44 152 134 34 176 12 121 96 27 250 193 49 100 173 65 218 5 35 211 95 93 40 36 55 170 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 50 183 50 54 214 54 52 176 50 48 0 0 65 105 5 11 107 71 126 81 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 50 183 50 54 214 54 52 176 50 48 0 0 65 105 5 11 9 127 137 174 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:48'!
villagecvillage1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 71 73 68 65 84 24 211 141 208 209 9 0 32 8 69 209 235 91 167 121 106 200 246 105 30 251 10 36 42 243 75 229 8 170 85 240 66 30 234 192 248 129 0 63 88 43 201 176 98 241 194 218 27 55 172 211 244 9 235 182 211 142 245 186 52 98 115 240 236 135 13 152 125 62 15 222 82 65 36 54 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:48'!
villagecvillage2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 73 73 68 65 84 40 207 173 204 177 17 0 32 8 67 209 232 58 204 131 251 111 130 5 71 163 199 1 226 47 146 238 13 17 0 208 237 180 150 254 252 5 17 53 193 19 178 202 160 7 149 193 8 74 131 89 40 4 171 144 11 190 66 23 216 133 172 193 12 0 34 93 200 218 63 158 15 201 9 199 11 155 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 179 50 54 209 54 52 176 50 48 0 0 65 113 5 12 205 195 217 81 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 179 50 54 209 54 52 176 50 48 0 0 65 113 5 12 175 251 46 174 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:48'!
villagecvillagec1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 57 73 68 65 84 24 211 141 207 177 13 0 64 8 66 209 239 144 220 254 155 96 107 97 60 76 40 32 175 17 129 29 4 131 149 194 4 51 139 82 120 97 182 81 41 220 48 215 3 74 225 196 101 48 159 123 64 3 239 134 175 168 78 69 192 53 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:48'!
villagecvillagec2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 71 73 68 65 84 40 207 99 252 255 159 129 129 129 1 66 82 2 194 194 160 12 152 129 228 210 161 161 168 124 178 13 68 55 136 108 3 113 25 68 178 129 132 12 34 218 64 98 13 34 104 32 169 6 225 52 144 92 131 48 12 164 212 32 184 129 212 50 8 70 3 0 215 31 95 93 182 74 91 9 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 180 50 48 213 54 52 176 50 48 0 0 65 46 5 5 235 29 227 192 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 50 179 50 54 209 54 52 176 50 48 0 0 65 102 5 11 252 199 66 127 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:48'!
villagefarm1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 72 73 68 65 84 24 211 141 208 209 9 0 32 8 69 209 219 163 109 156 167 125 218 167 33 235 43 136 40 213 47 149 35 168 165 193 28 157 48 100 64 203 64 128 12 214 78 34 172 179 240 176 238 198 15 235 53 253 194 250 237 116 99 121 151 158 184 70 255 51 128 14 11 127 124 11 64 177 110 235 32 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:48'!
villagefarm2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 73 73 68 65 84 40 207 173 206 177 13 0 32 8 68 209 211 201 221 199 121 152 7 11 130 133 134 0 202 111 174 123 185 54 6 0 48 227 51 34 217 94 5 205 41 215 158 193 19 210 210 160 5 165 65 15 10 131 81 200 5 179 144 9 190 66 23 248 11 109 176 10 210 22 219 61 40 188 121 147 157 21 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 49 176 50 50 211 54 52 176 50 48 0 0 65 70 5 8 43 140 136 88 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 178 180 50 54 212 54 52 176 50 48 0 0 65 111 5 11 172 73 236 14 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:48'!
villagefarmc1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 70 73 68 65 84 24 211 141 208 209 9 0 32 8 69 209 219 163 109 156 199 253 71 169 175 32 164 84 253 73 57 130 137 195 234 164 12 240 65 25 2 232 96 157 71 133 117 23 25 86 108 252 176 94 211 47 172 223 78 17 43 251 233 141 103 117 63 3 24 176 1 144 94 23 139 19 126 32 55 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/10/2011 17:42'!
villagefarmc2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 77 73 68 65 84 40 207 99 108 104 96 96 96 96 248 255 159 129 66 112 245 42 132 102 162 150 65 171 87 67 28 69 182 129 232 6 193 0 201 6 226 50 136 100 3 9 25 68 180 129 196 26 68 208 64 82 13 194 105 32 185 6 97 24 72 169 65 112 16 26 202 192 0 73 216 212 193 0 201 164 83 46 116 222 45 130 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 178 176 50 176 208 54 52 176 50 48 0 0 65 126 5 14 42 10 130 239 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 178 176 50 176 208 54 52 176 50 48 0 0 65 126 5 14 72 50 117 16 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:49'!
villagevillage1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 67 73 68 65 84 24 211 141 208 209 9 0 32 8 69 209 219 91 199 121 26 189 121 234 75 16 177 204 47 149 35 168 99 194 54 250 144 1 235 7 2 252 96 121 210 97 197 226 133 149 27 55 172 106 186 194 186 237 148 177 94 151 70 172 238 127 142 15 240 96 10 147 44 156 188 238 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:49'!
villagevillage2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 70 73 68 65 84 40 207 173 204 177 13 0 32 8 5 209 175 235 176 36 75 50 15 22 6 11 141 1 196 107 174 123 141 25 0 84 81 76 100 190 255 130 136 138 224 14 89 105 240 6 165 65 15 10 131 81 200 5 179 208 21 124 133 14 176 10 45 240 23 100 13 92 198 22 188 215 168 148 120 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 180 50 54 212 54 52 176 50 48 0 0 65 42 5 4 160 83 232 56 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 50 181 50 178 208 54 52 176 50 48 0 0 65 112 5 13 212 131 239 148 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:49'!
villagevillagec1Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 8 6 0 0 0 141 50 207 189 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 67 73 68 65 84 24 211 141 208 209 9 0 32 8 0 209 227 214 105 158 218 127 147 250 10 66 44 19 132 148 39 152 116 152 243 35 109 192 160 14 1 126 176 251 81 97 207 226 133 141 141 27 54 155 206 176 183 157 34 246 245 211 19 91 221 111 227 5 154 96 23 222 152 65 61 85 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!KmResources methodsFor: 'uploaded' stamp: 'StuartHerring 5/8/2011 11:49'!
villagevillagec2Png
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 0 10 16 6 0 0 0 221 162 19 254 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 6 98 75 71 68 255 255 255 255 255 255 9 88 247 220 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 9 118 112 65 103 0 0 0 10 0 0 0 10 0 78 166 118 229 0 0 0 77 73 68 65 84 40 207 173 210 177 17 0 16 16 68 209 79 143 250 81 143 126 212 115 2 67 192 152 115 206 79 54 123 209 134 156 1 68 112 86 107 223 248 11 42 197 9 174 208 200 12 158 32 51 168 65 215 224 45 164 130 86 232 8 190 66 27 232 133 102 41 1 136 244 107 251 183 1 11 248 67 46 140 44 189 124 0 0 0 46 122 84 88 116 99 114 101 97 116 101 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 54 176 50 177 208 54 52 176 50 48 0 0 65 89 5 11 50 56 94 243 0 0 0 46 122 84 88 116 109 111 100 105 102 121 45 100 97 116 101 0 0 120 218 51 50 48 52 212 53 48 213 53 176 8 49 52 180 50 50 179 50 50 208 54 52 176 50 48 0 0 65 66 5 6 230 46 246 7 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

WAComponent subclass: #KmDownloadGameLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmDownloadGameLink methodsFor: 'accessing' stamp: 'StuartHerring 4/10/2011 22:03'!
gameState
	^self session game sixxString! !

!KmDownloadGameLink methodsFor: 'rendering' stamp: 'StuartHerring 4/10/2011 22:05'!
renderContentOn: html
	html heading: 'Download Game State'.
	html anchor document: self gameState  mimeType:  'text/xml' fileName: 'vok-', DateAndTime now printString, '.xml';
		with: 'Click Here to Download Game'.
	html horizontalRule.
	html anchor callback: [self answer]; with: 'Done'! !

WAComponent subclass: #KmGameBoardComponent
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameBoardComponent class methodsFor: 'instance creation' stamp: 'StuartHerring 1/12/2011 19:28'!
for: aGame
	^self basicNew
		initializeWithGame: aGame;
		yourself! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:48'!
at: row at: column
	^game board at: row at: column! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:48'!
columns 
	^game board columns! !

!KmGameBoardComponent methodsFor: 'initialization' stamp: 'StuartHerring 1/17/2011 10:45'!
initializeWithGame: aGame
	self initialize.
	game:= aGame! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/20/2011 15:38'!
renderBlankSpotOn: html
	html tableData.! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 3/6/2011 12:22'!
renderContentOn: html
	html table border: 1; class: 'gameBoard';with: [
		1 to: self rows do: [ :r |
			html tableRow: [
				1 to: self columns do: [ :c |
					self renderTileAt: r at: c on: html]]]]! !

!KmGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 5/10/2011 17:47'!
renderTile: aTile on: html
	html tableData: 	(KmTileRenderable for: aTile)! !

!KmGameBoardComponent methodsFor: 'initialization' stamp: 'StuartHerring 5/10/2011 21:08'!
renderTileAt: row at: column on: html
	| tile |
	tile := self at: row at: column.
	tile isNil 
		ifTrue: [self renderBlankSpotOn: html]
		ifFalse: [self renderTile: tile on: html]! !

!KmGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 1/17/2011 10:48'!
rows
	^game board rows! !

KmGameBoardComponent subclass: #KmPlacePieceGameBoardComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmPlacePieceGameBoardComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/10/2011 22:15'!
renderTile: aTile on: html
	aTile = game lastTile 
		ifTrue: [ html tableData class: #lastTile; with:(KmPlacePieceTileRenderable for: aTile callback: [ :s | self answer: s])]
		ifFalse: [ html tableData:(KmTileRenderable for: aTile)]! !

KmGameBoardComponent subclass: #KmPlaceTileGameBoardComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmPlaceTileGameBoardComponent methodsFor: 'accessing' stamp: 'StuartHerring 5/10/2011 22:09'!
placeCurrentTileAtRow: row andColumn: column
	self answer: row@column.! !

!KmPlaceTileGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 5/10/2011 17:46'!
renderAvailableSpotFor: row at: column on: html
	html tableData class: #available; 
		onClick: ('window.location="', (html urlForAction: [self placeCurrentTileAtRow: row andColumn: column]) printString, '"').
! !

!KmPlaceTileGameBoardComponent methodsFor: 'rendering' stamp: 'StuartHerring 5/10/2011 21:09'!
renderTileAt: row at: column on: html
	(self tileIsValidAt: row at: column)
		ifTrue: [self renderAvailableSpotFor: row at: column on: html]
		ifFalse: [ super renderTileAt: row at:  column on: html]! !

!KmPlaceTileGameBoardComponent methodsFor: 'testing' stamp: 'StuartHerring 5/10/2011 17:48'!
tileIsValidAt: row at: column
	|  gameBoard |
	game currentTile ifNil: [^false].
	gameBoard := game board.
	^gameBoard canPlaceTile: game currentTile at: row at: column.! !

WAComponent subclass: #KmGameScreen
	instanceVariableNames: 'gameBoard summary tileList playerList currentPlayer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmGameScreen commentStamp: 'StuartHerring 5/9/2011 22:17' prior: 0!
The standard in game screen.  
Subclasses will represent a specific phase of the game, and will answer when the actions they are responsible for are completed!

!KmGameScreen methodsFor: 'actions' stamp: 'StuartHerring 4/25/2011 15:07'!
changeDisplayMode
	self session toggleDisplayMode! !

!KmGameScreen methodsFor: 'hooks' stamp: 'StuartHerring 5/11/2011 07:39'!
children
	| children |
	children := OrderedCollection withAll: {gameBoard .summary}.
	tileList ifNotNil: [ children add: tileList ].
	^children! !

!KmGameScreen methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 22:03'!
downloadGame
	self call: KmDownloadGameLink new.! !

!KmGameScreen methodsFor: 'accessing' stamp: 'StuartHerring 3/14/2011 11:58'!
game
	^self session game! !

!KmGameScreen methodsFor: 'accessing' stamp: 'StuartHerring 5/9/2011 22:50'!
gameBoard 
	"The Game Board class to use for this screen"
	self subclassResponsibility! !

!KmGameScreen methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 14:59'!
hideRemaining
	tileList := nil.! !

!KmGameScreen methodsFor: 'initialization' stamp: 'StuartHerring 5/11/2011 07:42'!
initialize
	super initialize.
	gameBoard := self gameBoard for: self game.
	gameBoard onAnswer: [ :a | self answer: a].
	summary := KmTerritorySummary new.
	playerList := KmPlayerList new.
	currentPlayer := KmCurrentPlayer new.
	tileList := nil.! !

!KmGameScreen methodsFor: 'accessing' stamp: 'StuartHerring 5/10/2011 18:00'!
menuItems
	| items |
	items := OrderedCollection new.
	tileList
		ifNil: [ items add: 'Show Remaining Tiles' -> [ self showRemaining ]]
		ifNotNil: [ items add: 'Hide Remaining Tiles' -> [ self hideRemaining ]].
	items add: ('Display Mode (' , self session displayMode , ')') -> [ self changeDisplayMode ].
	items add: 'Download Game' -> [ self downloadGame ].
	^items! !

!KmGameScreen methodsFor: 'rendering' stamp: 'StuartHerring 5/10/2011 21:13'!
renderContentOn: html
	self renderSidebarOn: html.
	self renderWaitingBayOn: html.  
	self renderGameBoardOn: html! !

!KmGameScreen methodsFor: 'rendering' stamp: 'StuartHerring 1/12/2011 12:08'!
renderGameBoardOn: html
	html render: gameBoard! !

!KmGameScreen methodsFor: 'rendering' stamp: 'StuartHerring 5/10/2011 17:58'!
renderMenuOn: html
	(html heading)
		level: 2;
		with: 'Menu'.
	(html unorderedList)
		id: #menu;
		with: [ self menuItems do: [ :m |
			html listItem: [html anchor callback: m value; with: m key ]
		]]! !

!KmGameScreen methodsFor: 'rendering' stamp: 'StuartHerring 5/11/2011 07:42'!
renderSidebarOn: html
	(html div)
		id: #sidebar;
		with: [ 
					html render: currentPlayer.
					self renderMenuOn: html.
					html render: playerList.
					html render: summary.
					tileList
						ifNotNil: [ 
							(html div)
								id: #tilelist;
								with: tileList ] ]! !

!KmGameScreen methodsFor: 'rendering' stamp: 'StuartHerring 5/10/2011 21:23'!
renderWaitingBayOn: html
	  html render: (KmTextTileRenderable text: '')! !

!KmGameScreen methodsFor: 'actions' stamp: 'StuartHerring 4/10/2011 15:02'!
showRemaining
	tileList := KmTileList new
		onAnswer: [ self hideRemaining];
		yourself.! !

!KmGameScreen methodsFor: 'accessing' stamp: 'StuartHerring 5/10/2011 17:52'!
tilesRemaining
	^self session game isComplete not! !

!KmGameScreen methodsFor: 'updating' stamp: 'StuartHerring 3/14/2011 12:16'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: (KmResources urlOf: #styleCss).
	anHtmlRoot title: 'Villages of Khami: ', self game tileSet name.
		
! !

KmGameScreen subclass: #KmPlacePieceScreen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmPlacePieceScreen methodsFor: 'accessing' stamp: 'StuartHerring 5/10/2011 21:05'!
gameBoard
	^KmPlacePieceGameBoardComponent ! !

!KmPlacePieceScreen methodsFor: 'accessing' stamp: 'StuartHerring 5/10/2011 22:34'!
renderWaitingBayOn: html
	html render: ((KmTextTileRenderable text: 'Skip')
		callback: [self answer: nil];
		yourself)! !

KmGameScreen subclass: #KmPlaceTileScreen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmPlaceTileScreen methodsFor: 'actions' stamp: 'StuartHerring 5/10/2011 22:10'!
discardTile
	self session game discardTile.
	self session game isComplete ifTrue: [self answer]! !

!KmPlaceTileScreen methodsFor: 'accessing' stamp: 'StuartHerring 5/10/2011 17:48'!
gameBoard
	^KmPlaceTileGameBoardComponent ! !

!KmPlaceTileScreen methodsFor: 'accessing' stamp: 'StuartHerring 5/10/2011 18:02'!
menuItems
	| items |
	items := super menuItems.
	self session currentTile
		ifNotNil: [ 
			items add: 'Rotate Tile' -> [ self rotateTile ].
			self game validMoveAvailable
				ifFalse: [ items add: 'Discard Dead Tile' -> self discardTile ]].
	^items! !

!KmPlaceTileScreen methodsFor: 'rendering' stamp: 'StuartHerring 5/10/2011 21:12'!
renderWaitingBayOn: html
		self session currentTile 
			ifNil: [self tilesRemaining 
					ifTrue: [html render: 
						((KmTextTileRenderable text: 'Take Tile') callback: [self takeTile])]
					ifFalse: [html render: (KmTextTileRenderable text: '')]]
			ifNotNil: [html render: 
				((KmTileRenderable for: self session currentTile) callback: [self rotateTile])].
! !

!KmPlaceTileScreen methodsFor: 'actions' stamp: 'StuartHerring 5/10/2011 17:51'!
rotateTile
	self session currentTile rotate! !

!KmPlaceTileScreen methodsFor: 'actions' stamp: 'StuartHerring 5/10/2011 17:51'!
takeTile
	self session game takeTile! !

KmGameScreen subclass: #KmVictoryScreen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmVictoryScreen methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/14/2011 22:06'!
gameBoard
	^KmPlaceTileGameBoardComponent ! !

!KmVictoryScreen methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/14/2011 22:07'!
renderGameBoardOn: html
	html div class:#disabled; with: gameBoard! !

!KmVictoryScreen methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/14/2011 22:14'!
renderWaitingBayOn: html
	| players winner |
	players := self session game players.
	winner := players inject: nil into: [ :w :p | (w notNil and: [w score > p score]) ifTrue: [w] ifFalse: [p]].
	html heading level: 3; with: winner name, ' wins!!'.
	html anchor callback: [self answer]; with: 'New Game' ! !

WAComponent subclass: #KmSetupGame
	instanceVariableNames: 'tileSets tileSet savedGame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmSetupGame class methodsFor: 'testing' stamp: 'StuartHerring 3/14/2011 08:54'!
canBeRoot
	^true! !

!KmSetupGame methodsFor: 'initialization' stamp: 'StuartHerring 3/14/2011 15:33'!
initialize
	super initialize.
	tileSets := KmTileSet tileSets asOrderedCollection.
	tileSet := tileSets first.! !

!KmSetupGame methodsFor: 'rendering' stamp: 'StuartHerring 4/10/2011 22:16'!
renderContentOn: html
	html heading level: 1; with: 'Choose a tile set or Upload Game'.
	html form multipart; with: [
		self renderTileSetsOn: html.
		self renderUploadOn: html.
		html submitButton callback: [ self submitClicked]; with: 'Ok'].! !

!KmSetupGame methodsFor: 'rendering' stamp: 'StuartHerring 3/21/2011 23:07'!
renderTileSetsOn: html
	html select 
		on: #tileSet of: self; 
		list: tileSets;
		labels: [ :ts | ts tilesetName]! !

!KmSetupGame methodsFor: 'rendering' stamp: 'StuartHerring 4/10/2011 22:22'!
renderUploadOn: html
	html div: [
		html fileUpload callback: [ :f | savedGame := Object readSixxFrom: f contents]]! !

!KmSetupGame methodsFor: 'actions' stamp: 'StuartHerring 5/10/2011 22:32'!
submitClicked
	self answer: (savedGame ifNil: [(KmGame tileSet: tileSet new) 
			addPlayer: (KmPlayer named: 'Player 1' withColour: Color blue); 
			addPlayer: (KmPlayer named: 'Player 2' withColour: Color magenta);
			yourself])! !

!KmSetupGame methodsFor: 'accessing' stamp: 'StuartHerring 3/14/2011 09:01'!
tileSet
	^tileSet! !

!KmSetupGame methodsFor: 'accessing' stamp: 'StuartHerring 3/14/2011 10:12'!
tileSet: aSet
	tileSet := aSet! !

WAComponent subclass: #KmTerritorySummary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTerritorySummary methodsFor: 'rendering' stamp: 'StuartHerring 1/30/2011 23:46'!
render: aCollection named: aString on: html
	html definitionTerm: aString.
	html definitionData: [
		html render: aCollection size;
			render: ' (';
			render: (aCollection select: [ :t | t isComplete ]) size;
			render: ')']! !

!KmTerritorySummary methodsFor: 'rendering' stamp: 'StuartHerring 4/25/2011 15:00'!
renderContentOn: html
	| territories |
	territories := self session game territories.
	html heading level: 2; with: 'Summary'.
	html definitionList id: #summary; with: [ 
		self render: (territories select: [ :t | t type = #road]) named: 'Roads' on: html.
		self render: (territories select: [ :t | t type = #farm]) named: 'Farms' on: html.
		self render: (territories select: [ :t | t type = #village]) named: 'Villages' on: html.
		self render: territories  named: 'Total' on: html.
	].
! !

WAComponent subclass: #KmTileList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmTileList class methodsFor: 'testing' stamp: 'StuartHerring 1/9/2011 18:25'!
canBeRoot
	^true! !

!KmTileList methodsFor: 'accessing' stamp: 'StuartHerring 3/14/2011 12:18'!
game
	^self session game! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 4/22/2011 17:12'!
renderContentOn: html
	| id |
	(html heading)
		level: 2;
		with: 'Tiles Remaining'.
	html paragraph: self game tileSet name.
	(html anchor)
		callback: [ self answer ];
		with: 'Close'.
	html unorderedList
		style: 'padding: 0' ;
		id:  (id := html nextId);
		script: (html scriptaculous sortable 
			onUpdate: (html scriptaculous request triggerSortable: id 
			callback: [ :value | self updateTiles: value] ));
		with: [ self renderTilesOn: html].! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 4/10/2011 14:49'!
renderTilesOn: html
	self tiles
		do: [ :t | 
			(html listItem)
				style: 'display: inline-block';
				passenger: t;
				with: (KmTileRenderable for: t) ]! !

!KmTileList methodsFor: 'accessing' stamp: 'StuartHerring 4/10/2011 14:35'!
tiles
	^self session game tileSet instVarNamed: 'tiles'! !

!KmTileList methodsFor: 'rendering' stamp: 'StuartHerring 4/10/2011 14:50'!
updateTiles: newCollection
	self session game tileSet instVarNamed: #tiles put: newCollection asOrderedCollection! !

WASession subclass: #KmSession
	instanceVariableNames: 'game frozen displayMode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Khami-Web'!

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 5/10/2011 21:44'!
currentPlayer
	^game currentPlayer! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2011 19:42'!
currentTile
	^game currentTile! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 4/25/2011 15:08'!
displayMode
	^displayMode! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 2/1/2011 20:25'!
freeze
	frozen := true! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 5/10/2011 21:44'!
game
	^game! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 4/10/2011 22:12'!
game: aGame
	game := aGame.! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 4/25/2011 15:08'!
initialize
	super initialize.
	frozen := false.
	displayMode := #symbolic! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 2/1/2011 20:26'!
isFrozen
	^frozen! !

!KmSession methodsFor: 'initialization' stamp: 'StuartHerring 4/25/2011 15:11'!
toggleDisplayMode
	displayMode := (displayMode = #symbolic) ifTrue: [#literal] ifFalse: [#symbolic]! !

!KmSession methodsFor: 'accessing' stamp: 'StuartHerring 2/1/2011 20:25'!
unfreeze
	frozen := false! !
KmGameTask initialize!
